function varargout=simplicial2D(varargin)
  p = inputParser; 
  p.addParamValue('verbose',true,@islogical);
  p.addParamValue('small',true,@islogical);
  p.parse(varargin{:});
  verbose=p.Results.verbose;
  small=p.Results.small;
  name=mfilename();
  if verbose,fprintf('*** Running %s demo\n',name);end
  u=@(x,y) 3*exp(-((x-1).^2+y.^2)/10).*cos(x-1).*sin(y);
  small=true;
  [q2,me2,toGlobal2]=fc_meshtools.simplicial.getMesh2D(2,small);
  if verbose, fprintf('  -> d=2, q %d-by-%d array, me %d-by-%d array\n',size(q2),size(me2)); end
  [q1,me1,toGlobal1]=fc_meshtools.simplicial.getMesh2D(1,small);
  if verbose, fprintf('  -> d=1, q %d-by-%d array, me %d-by-%d array\n',size(q1),size(me1)); end
  
  res=0;
  E=norm(q2(:,toGlobal1)-q1,Inf);
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with E=%g\n',E);else fprintf('  Test 1: OK\n');end;end
  
  U2=fc_meshtools.eval(u,q2);
  U1=fc_meshtools.eval(u,q1);
  
  E=max(abs(U2(toGlobal1)-U1));
  res=res+(E >1e-15);
  if verbose,if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  
  if nargout==1,varargout{1}=(res==0);end
  
end
