function varargout=NormalFaces(q,me,varargin)
  % Normal (d+1)-by-d-by-nme 3D array
  %   
  assert(ismember(nargout,1:2));
  [dim,d,nq,nme]=fc_meshtools.simplicial.get_dims(q,me);
  p = inputParser; 
  p.addParamValue('GradBaCo',[]);
  p.parse(varargin{:});
  GradBaCo=p.Results.GradBaCo;
  if isempty(GradBaCo), GradBaCo=fc_meshtools.simplicial.GradBaCo(q,me); end
    
  [IndLocFaces,IndOpositePt]=fc_meshtools.simplicial.getIndLocFaces(d);
  Normal=zeros(d+1,dim,nme);
  for i=1:d+1
    A=-squeeze(GradBaCo(:,:,i))';
    Normal(i,:,:)=A; % direction normal exterieur non normalisee au i-eme (d-1)-simplex dans le d-simplex
    N2=sqrt(sum(squeeze(Normal(i,:,:)).^2,1));
    for j=1:dim
      Normal(i,j,:)=squeeze(Normal(i,j,:))./N2';
    end
  end
  if nargout>=1,varargout{1}=Normal;end
  if nargout==2,varargout{2}=GradBaCo;end
end
