function vols=Volumes(q,me)
  % Compute volume of d-simplices
  % d-simplex in R^n (d<=n)
 [n,d,nq,nme]=fc_meshtools.simplicial.get_dims(q,me);
 At=zeros(d,n,nme);I=zeros(d,n,nme);J=zeros(d,n,nme);
  L=0:(nme-1);
  for i=1:d 
    At(i,:,:)=q(:,me(i+1,:))-q(:,me(1,:));
    I(i,:,:)=repmat(L*d+i,[n,1]);
    for j=1:n
      J(i,j,:)=L*n+j;
    end
  end
  spAK=sparse(I(:),J(:),At(:),d*nme,n*nme);
  if d==n
    [L,U]=lu(spAK);
    U=reshape(full(diag(U)),d,nme);
    vols=abs(prod(U,1))/factorial(d);
  else
    spH=spAK*spAK';
    L=chol(spH);
    L=reshape(full(diag(L)),d,nme);
    vols=prod(L,1)/factorial(d);
  end
end 

